//Author Antonio-Gabriel Sturzu

#include<stdio.h>
#include<time.h>
#define lim 100001

int main()
{
	int m[1000][1000],n,i,j,k;
	clock_t start,stop;
	FILE *f=fopen("royfloyd.in","r");

	fscanf(f,"%i",&n);
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
		{
			fscanf(f,"%i",&m[i][j]);
			if(i!=j && m[i][j]==0)
				m[i][j]=lim;
		}
	fclose(f);

	start=clock();
	for(k=0;k<n;k++)
		for(i=0;i<n;i++)
			for(j=0;j<n;j++)
				if(m[i][k]+m[k][j]<m[i][j])
					m[i][j]=m[i][k]+m[k][j];
	stop=clock();
	printf("Au trecut %f secunde\n",(double)(stop-start)/CLOCKS_PER_SEC);
	f=fopen("royfloyd.out","w");
	for(i=0;i<n;i++)
	{
		for(j=0;j<n-1;j++)
		{
			if(m[i][j]==lim)
				m[i][j]=0;
			fprintf(f,"%i ",m[i][j]);
		}
		if(m[i][n-1]==lim)
			m[i][n-1]=0;
		fprintf(f,"%i\n",m[i][n-1]);
	}
	fclose(f);
	return 0;
}
